/* 
	Copyright (c) 2008 Lars Bergelt Visual Art & Design. All rights reserved.
	info@lbergelt.de
	www.lbergelt.de
*/


	var einzufuegendeBilder = new Array();
	var currentVersion;
	var zufallszahl;
    var countNumber;
	var lastShowcaseCover;
	var urlVersion = "http://www.lbergelt.de/widget/production_paradise/version.php";
	var urlInfoEn = "http://www.lbergelt.de/widget/production_paradise/info_en.php";
    
    var directoriesURL = "http://www.productionparadise.com/directories.php";
    var categoryURL ="http://iphone.productionparadise.com/index.php";
//    var showcasesURL = "http://www.productionparadise.com/showcases.php";
    var showcasesURL = "http://www.productionparadise.com/photo-showcases.html";
    var urlCat = "http://www.productionparadise.com/ajax_search_form_updated.php?Section=Directory&CategoryID="; 
    
    
function load()
{
    dashcode.setupParts();
    loadPrefs();
	checkversion();
    selectsLaden();
    bildladen();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
	widget.setPreferenceForKey(null, createInstancePreferenceKey("updateCheck"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    selectsLaden();
	bildladen();
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    if (zufallszahl == "2")
	{
	zufallsgenerator();
	}
	loadPrefs();
	checkUpdateInput();
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

function loadPrefs()
{
	var updChe = widget.preferenceForKey("updateCheck");

	if (updChe != false)
	{
	document.getElementById("updateInput").checked = true;
	}
	else {
	document.getElementById("updateInput").checked = false;
	}
}

function checkUpdateInput()
{
	if (document.getElementById("updateInput").checked == true)
	{
	checkForUpdate();
	}
	else {
	return true;
	}
}

function onClickKeyword() {
    document.getElementById('keywordButton').style.background = 'url(Images/keywordButton_on.png)';
    document.getElementById('mediaButton').style.background = 'url(Images/mediaButton_off.png)';
    document.getElementById('categoryButton').style.background = 'url(Images/categoryButton_off.png)';
    document.getElementById('keywordBox').style.display = 'block';
    document.getElementById('mediaBox').style.display = 'none';
    document.getElementById('categoryBox').style.display = 'none';
}

function onClickMedia() {
    document.getElementById('keywordButton').style.background = 'url(Images/keywordButton_off.png)';
    document.getElementById('mediaButton').style.background = 'url(Images/mediaButton_on.png)';
    document.getElementById('categoryButton').style.background = 'url(Images/categoryButton_off.png)';
    document.getElementById('keywordBox').style.display = 'none';
    document.getElementById('mediaBox').style.display = 'block';
    document.getElementById('categoryBox').style.display = 'none';
}
    
function onClickCategory() {
    document.getElementById('keywordButton').style.background = 'url(Images/keywordButton_off.png)';
    document.getElementById('mediaButton').style.background = 'url(Images/mediaButton_off.png)';
    document.getElementById('categoryButton').style.background = 'url(Images/categoryButton_on.png)';
    document.getElementById('keywordBox').style.display = 'none';
    document.getElementById('mediaBox').style.display = 'none';
    document.getElementById('categoryBox').style.display = 'block';
}

function savesetup()
{
	widget.setPreferenceForKey(document.getElementById("updateInput").checked, "updateCheck");
}

function searchByKeyword() 
{
widget.openURL("http://www.productionparadise.com/keyword_search.php?q="+ document.getElementById("keywordSearch").value + "&t=keyword&pl=1&pn=1");
}

function searchByMedia()
{
widget.openURL("http://www.productionparadise.com/media_search.php?q="+ document.getElementById("mediaSearch").value + "&t=media&pl=1&pn=1");
}

/**
  *
  * Categorien Laden
  *
  **/
function selectsLaden()
{
	try {
	var req = new XMLHttpRequest (); 
	req.open ('GET', categoryURL, false); 
//  req.open ('GET', directoriesURL, false);
    req.setRequestHeader("Cache-Control", "no-cache"); 
	req.send(null);
	response = req.responseText;
	
	document.getElementById("loadOn").style.display = "none";
	document.getElementById("error").style.display = "none";
	document.getElementById('widgetFront').style.display='block';

	categoryClear();
	zerlegeCategory(response);
	
	} 
	catch (errv) {
		errorFunction();
	}
}

function zerlegeCategory(input)
{
//    selectCategoryStart = input.indexOf('<select name="search_category" id="category" name="search_category" onchange="CategoryChanged();" >');
    selectCategoryStart = input.indexOf('<select name="category_id" id="search_category">');
      
//	selectCategoryEnd = input.indexOf('		</select>');
    selectCategoryEnd = input.indexOf('    </select>');
    
//	selectCategory = input.substring(selectCategoryStart + 99, selectCategoryEnd + 11);
    selectCategory = input.substring(selectCategoryStart + 48, selectCategoryEnd + 13);

	document.getElementById("category").innerHTML = selectCategory;

    entferneCategory = input.substring(0, selectCategoryEnd + 19);
	output1 = input.replace(entferneCategory, "");

	selectCountryStart = output1.indexOf('<select id="search_country" name="search_country"  disabled=');
	selectCountryEnd = output1.indexOf('</select>');
	selectCountry = output1.substring(selectCountryStart + 71, selectCountryEnd);	
		
	document.getElementById("country").innerHTML = selectCountry;

	entferneCountry = output1.substring(selectCountryStart, selectCountryEnd + 9);
	output2 = output1.replace(entferneCountry, "");

	selectCityStart = output2.indexOf('<select id="search_city" name="search_city"  disabled=');
	selectCityEnd = output2.indexOf('</select>');
	selectCity = output2.substring(selectCityStart + 65, selectCityEnd);	
	
	document.getElementById("city").innerHTML = selectCity;
	

}

/* Suchen */
function search()
{
	var searchCategory = document.Search.search_category.options[document.Search.search_category.selectedIndex].value;
	var searchCountry = document.Search.search_country.options[document.Search.search_country.selectedIndex].value;
	var searchCity = document.Search.search_city.options[document.Search.search_city.selectedIndex].value;
	var searchWord = document.getElementById("searchField").value;


	if (document.getElementById("country").disabled == true)
	{
	widget.openURL("http://www.productionparadise.com/search_results.php?category_id=" + searchCategory + "&search_word=" + searchWord);
	}
	else {
	widget.openURL("http://www.productionparadise.com/search_results.php?category_id=" + searchCategory + "&country_id=" + searchCountry + "&city_id=" + searchCity + "&search_word=" + searchWord);
	}

}


function delOptions2(sel) {
	i = sel.options.length - 1;
	while (i > 1)
		sel.options[i--] = null;
}

function insOption(sel, value, text) {
	sel.options[sel.length] = new Option(text,value);
}


function getHTTPObject() {
  var xmlhttp;
  if (!xmlhttp && typeof XMLHttpRequest != 'undefined') {
    try {
      xmlhttp = new XMLHttpRequest();
    } catch (e) {
      xmlhttp = false;
    }
  }
  return xmlhttp;
}

var http = getHTTPObject();
var isWorking = false;
var preloadMode = false;

function clearSelect(sel) {
	while (sel.length > 0)
		sel.options[0] = null;
}

function fillCountries(xmlDocument) {
	var sel = '';
	if (document.Search.search_country.selectedIndex > -1)
		sel = document.Search.search_country.options[document.Search.search_country.selectedIndex].value;
	clearSelect(document.Search.search_country);
	document.Search.search_country.options[document.Search.search_country.length] = new Option("Select Country", "");
	document.Search.search_country.options[document.Search.search_country.length] = new Option("Worldwide", "");
	var pages = xmlDocument.getElementsByTagName('countries');
	for (var i=0; i<pages.length; i++) {
		var pgs = pages.item(0).childNodes;
		for (var j=0; j<pgs.length; j++) {
				if (pgs.item(j).toString() == '[object Element]') {
					id = pgs.item(j).getElementsByTagName("id").item(0).childNodes[0].nodeValue;
					name = pgs.item(j).getElementsByTagName("name").item(0).childNodes[0].nodeValue;
					document.Search.search_country.options[document.Search.search_country.length] = new Option(name, id);
					if (id == sel)
						document.Search.search_country.selectedIndex = document.Search.search_country.length - 1;
				}
		}
	}
}

function fillCities(xmlDocument) {
	var sel = '';
	if (document.Search.search_city.selectedIndex > -1)
		sel = document.Search.search_city.options[document.Search.search_city.selectedIndex].value;
	clearSelect(document.Search.search_city);
	document.Search.search_city.options[document.Search.search_city.length] = new Option("Select Cities", "");
	document.Search.search_city.options[document.Search.search_city.length] = new Option("All Cities", "");
	var pages = xmlDocument.getElementsByTagName('cities');
	for (var i=0; i<pages.length; i++) {
		var pgs = pages.item(0).childNodes;
		for (var j=0; j<pgs.length; j++) {
				if (pgs.item(j).toString() == '[object Element]') {
					id = pgs.item(j).getElementsByTagName("id").item(0).childNodes[0].nodeValue;
					name = pgs.item(j).getElementsByTagName("name").item(0).childNodes[0].nodeValue;
					document.Search.search_city.options[document.Search.search_city.length] = new Option(name, id);
					if (id == sel)
						document.Search.search_city.selectedIndex = document.Search.search_city.length - 1;
				}
		}
	}
}

function handleHttpResponse() {
  if (http.readyState == 4) {
    if (http.responseText.indexOf('invalid') == -1) {
      var xmlDocument = http.responseXML; 
			fillCountries(xmlDocument);
			fillCities(xmlDocument);
			categoryLoadEnd();
      isWorking = false;
			if (preloadMode)
				countryChanged();
    }
  }
}

function categoryChanged() {
	categoryLoadStart();
	document.Search.search_country.disabled = document.Search.search_category.selectedIndex <= 0;
	document.Search.search_city.disabled = document.Search.search_category.selectedIndex <= 0;
  if (!isWorking && (typeof http == 'object')) {
		var u = urlCat + document.Search.search_category.options[document.Search.search_category.selectedIndex].value + '&get=countries,cities';
    http.open("GET", u, true);
    http.onreadystatechange = handleHttpResponse;
    isWorking = true;
    http.send(null);
  }
}


function handleHttpResponseCountry() {
  if (http.readyState == 4) {
    if (http.responseText.indexOf('invalid') == -1) {
      var xmlDocument = http.responseXML; 
			fillCities(xmlDocument);
			categoryLoadEnd();
      isWorking = false;
			preloadMode = false;
    }
  }
}

function countryChanged() {
	categoryLoadStart();
  if (!isWorking && (typeof http == 'object')) {
		var u = urlCat + document.Search.search_category.options[document.Search.search_category.selectedIndex].value +
			'&CountryID=' + document.Search.search_country.options[document.Search.search_country.selectedIndex].value +
			'&get=cities';
    http.open("GET", u, true);
    http.onreadystatechange = handleHttpResponseCountry;
    isWorking = true;
    http.send(null);
  }
}

function preload() {
	preloadMode = true;
	CategoryChanged();
}

function categoryLoadStart() 
{
	document.getElementById("categoryLoader").style.display = "block";
}

function categoryLoadEnd()
{
	document.getElementById("categoryLoader").style.display = "none";
}

function errorFunction()
{
		document.getElementById("loadOn").style.display = "none";
		document.getElementById("error").style.display = "block";
		document.getElementById("widgetFront").style.display = "none";
}

function ladevorgang()
{
	document.getElementById("error").style.display = "none";
	document.getElementById("loadOn").style.display = "block";
	setTimeout('load();', 3000);
}

function categoryClear()
{
	document.Search.search_category.selectedIndex = 0;
	document.Search.search_country.selectedIndex = 0;
	document.Search.search_city.selectedIndex = 0;
	document.Search.search_country.disabled = document.Search.search_category.selectedIndex <= 0;
	document.Search.search_city.disabled = document.Search.search_category.selectedIndex <= 0;
    document.getElementById("keywordSearch").value = "";
    document.getElementById("mediaSearch").value = "";
	document.getElementById("searchField").value = "";
}




/**
  *
  * Bilder Laden
  *
  **/
  
function bildladen()
{
    try {
	var req = new XMLHttpRequest (); 
	req.open ('GET', showcasesURL, false);
	req.setRequestHeader("Cache-Control", "no-cache"); 
	req.send(null);
	showcaseResponse = req.responseText;

	document.getElementById("loadOn").style.display = "none";
	document.getElementById("error").style.display = "none";
	document.getElementById("widgetFront").style.display = "block";
	
	zerlegen(showcaseResponse);
	} 
	catch (errv) {
    	errorFunction();
	}

}

function zerlegen(input)
{
    bildContentStart = input.indexOf('<ul class="showcase">');
    bildContentEnd = input.indexOf('<div class="clear"></div>');
	bildContent = input.substring(bildContentStart, bildContentEnd);
	
	lastShowCoverStart = input.indexOf('src="/newsletters/');
  	lastShowCoverEnd = input.indexOf('/photos/main.jpg" alt="');
    
	lastShowCover = input.substring(lastShowCoverStart, lastShowCoverEnd);
    
	if (lastShowCover == lastShowcaseCover)
	{
	zufallsgenerator();
	}
	else {
	lastShowcaseCover = lastShowCover;
	erstesBild(bildContent);
    zerlegeShowcaseCover(bildContent);
    }

}

function erstesBild(input)
{
	bildStart = input.indexOf('src="');
	bildEnd = input.indexOf('" alt="');
	bild = input.substring(bildStart + 5, bildEnd);	
	bildEinfuegen(bild);    
}

function bildEinfuegen(input)
{
    bildurl = '<img src="http://www.productionparadise.com' + input + '" height="122px">';

	document.getElementById("showcaseCoverBox").innerHTML = bildurl;
	
	setTimeout('zufallsgeneratorAktivieren();', 60000);
	
}

function zerlegeShowcaseCover(input)
{
          
	coverStart = input.indexOf('src="');
	
	if (input.indexOf('" alt="') > -1)
	{
    
	coverEnd = input.indexOf('" alt="');
	cover = '<img src="http://www.productionparadise.com' + input.slice(coverStart + 5, coverEnd) + '" height="122px">';	
	einzufuegendeBilder.splice(1, 0 , cover);

	ersetzeDas = input.substring(0, coverEnd + 7);
	ersetzeDurch = '';
	output = input.replace(ersetzeDas, ersetzeDurch);

    zerlegeShowcaseCover(output);
    }
	else
	{
	
	}
}

function zufallsgeneratorAktivieren()
{
	zufallszahl = "2";
}

function zufallsgenerator()
{
	var anzahl = einzufuegendeBilder.length;
	var nr = Math.round(Math.random()*(anzahl-1));

	document.getElementById("showcaseCoverBox").innerHTML = einzufuegendeBilder[nr];
}

/* Versions Info */
function checkversion() { 
    currentVersion = getKeyValue("Info.plist", "CFBundleVersion"); 
	document.getElementById("version").innerText = ("Production Paradise Search v" + currentVersion);
	document.getElementById("aktuelleVersion").innerText = (currentVersion);
}

/* Update Check */
function checkForUpdate() { 
    req = new XMLHttpRequest(); 
    req.onreadystatechange = compareVersion; 
    req.open("GET", urlVersion, true);
    req.setRequestHeader("Cache-Control", "no-cache"); 
    req.send(null); 
} 

function compareVersion() { 
  if (req.readyState == 4) { 
    if (req.status == 200) { 
        var serverVersion = req.responseText; 
		document.getElementById("neueVersion").innerText = (serverVersion);
		document.getElementById("updateInfoVersion").innerText = (serverVersion);
        
		if ((currentVersion != serverVersion) && (serverVersion != null) && (serverVersion != "")) { 
            document.getElementById('update').style.display='block'; 
        } else { 
            document.getElementById('update').style.display='none'; 
        } 
    } 
  } 
} 

function getKeyValue(plist, key) { 
   var xml_http = new XMLHttpRequest(); 
   xml_http.open("GET", plist, false); 
   xml_http.send(null); 
    
   var xml = xml_http.responseXML; 
   var key_value = null; 
   var nodes = xml.getElementsByTagName("dict")[0].childNodes; 

   for (var i=0; i < nodes.length; i++) { 
      if (nodes[i].nodeType == 1 && nodes[i].tagName.toLowerCase() == "key" && nodes[i].firstChild.data == key) { 
         if (nodes[i+2].tagName.toLowerCase() != "array") { 
            key_value = nodes[i+2].firstChild.data; 
         } else { 
            key_value = new Array(); 
            var ar_nodes = nodes[i+2].childNodes; 
            for (var j=0; j < ar_nodes.length; j++) { 
               if (ar_nodes[j].nodeType == 1) key_value.push(ar_nodes[j].firstChild.data); 
            } 
         } 
          
         break; 
      } 
   } 
   return key_value; 

} 

function updateInfo()
{
	var req = new XMLHttpRequest (); 
	req.open ('get', urlInfoEn, false);
	req.send (null);
	versionsText = req.responseText; 

	document.getElementById("infoUpdateText").innerHTML = versionsText;

 }

